#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define BUFFER 100

unsigned int randaux()
{
	static long seed=1;
	return(((seed = seed * 214013L + 2531011L) >> 16) & 0x7fff);
}

/* Implementao do procedimento MostraLamberta - imprime o tabuleiro */
void MostraLamberta(int arr[], int tamanho){

	for (int i = 0; i < tamanho; i++)
	{
		if (arr[i]==0){
			printf("%s","O");
		} else {
			printf("%s","X");
		}
	}
	printf("\n");
}

/* Implementao do procedimento ImprimeCabecalho - imprime o cabealho do tabuleiro*/
void ImprimeCabecalho(int tamanho){
   if (tamanho>=100){
		for (int i = 1; i < tamanho + 1; i++)
		{
			if (i % 100 !=0){
				printf("%s"," ");
			} else{
				printf("%d", i/100);
			}
		}
		printf("\n");
		for (int i = 1; i < tamanho + 1; i++)
		{
			if (i % 10 !=0){
				printf("%s"," ");
			} else{
				 
				printf("%d", (i % 100)/10);
			}
		}
		printf("\n");
	}else{
		if (tamanho>=10){
			for (int i = 1; i < tamanho + 1; i++)
			{
				if (i % 10 !=0){
					printf("%s"," ");
				} else{
					printf("%d", i/10);
				}
			}
			printf("\n");
		}
	}
	for (int i = 1; i < tamanho + 1; i++)
	{ 
		printf("%d", i%10); 
	}
	printf("\n");
}

/* Implementao do procedimento GeraLamberta - gera um novo tabuleiro */
void GeraLamberta(int arr[], int tamanho){
	for (int i = 0; i < tamanho; i++)
	{
		int aux=randaux();
		if (aux % 2 == 0){
			arr[i]=0;
		} else {
			arr[i]=1; 
		}
	}
}

/* Implementao do procedimento JogadaValida - V se uma jogada  vlida ou no */
int JogadaValida(int arr[], int casa, int elementos){
	/* verificar se nas posies existe pelo menos um um */
	for (int i = casa - 1; i < casa + elementos - 1; i++)
	{ 
		if (arr[i]== 1){
			i = casa + elementos;
			return 1;
		}
	}
	return 0;
} 

/* Implementao do procedimento EfetuaJogada  - efetua a jogada no tabuleiro*/
void EfetuaJogada(int arr[], int casa, int elementos){
	for (int i = casa - 1; i < casa + elementos - 1; i++)
    { 
		if (arr[i]== 0){
			arr[i]=1;
		} else {
			arr[i]=0; 
		}
    }
} 
/* 
Este  o main a ser usado quando se pretende que a leitura dos dados
seja efetuado de uma s vez
*/
void main()
{
	/* flag que comuta a insero das jogadas de insero nica para jogada a jogada */
	int insercao_unica=1;
	
	int totalarrayjogadas, arrayjogadas[BUFFER];
	int i, valida, saltos, tamanho, jogada, casa, elementos, tabuleiro[BUFFER];
	// leitura dos dados - tamanho do tabuleiro e a quantidade de numeros aleatorios que salta
	scanf("%d %d", &tamanho, &saltos);
    
	// saltar os primeiros nmeros aleatrios, para ter sequncias distintas
	for(i=0;i<saltos;i++) 
		randaux();
    
   if (insercao_unica==1){
		//Leitura da informao
		//L uma cadeira de inteiros separados por espaos
		// e armazena-os num array
		char str[BUFFER];  
		fgets(str,BUFFER,stdin);
		
		
		totalarrayjogadas=0;
		char *pt=(char*)strtok(str," ");
		while(pt!=NULL) {
			arrayjogadas[totalarrayjogadas]=atoi(pt);
			totalarrayjogadas++; 
			pt=(char*)strtok(NULL," ");
		}
	}
		
	/* Chamar o procedimento para gerar um novo tabuleiro */
	GeraLamberta(tabuleiro, tamanho);
	/* Chamar o procedimento para imprimir o cabealho */
	ImprimeCabecalho(tamanho);
	/* Chamar o procedimento para mostrar o tabuleiro */
	MostraLamberta(tabuleiro, tamanho);
	jogada=0;
	i=0;
	valida=1;
	while (valida==1){
		jogada++;
		if (insercao_unica==1){
			//carrega a jogada a efetuar
			casa=arrayjogadas[i];
			i++;
			elementos=arrayjogadas[i];
			i++;
			printf("Jogada [%d]:%d %d\n", jogada, casa, elementos); 
		} else {
			printf("Jogada [%d]:", jogada);
			/* L valores */		
			scanf("%d %d", &casa, &elementos);
		}
	
		//Verifica se a jogada pretendida  vlida
		if ((elementos <= tamanho - jogada) && (casa+elementos-1<=tamanho)){
			valida=JogadaValida(tabuleiro, casa, elementos);
		} else { 
			valida=0;
		}
		 
		if (valida==0){
			// Jogada invlida
			if (jogada % 2==0){
				printf("Jogada invlida, perde jogador 2.");
				
			} else {
				printf("Jogada invlida, perde jogador 1.");
			}
			 
		} else {
			// Jogada vlida
			
			/* Chamar o procedimento para efetuar a jogada no tabuleiro */
			EfetuaJogada(tabuleiro, casa, elementos);
			/* Chamar o procedimento para imprimir o cabealho */
			ImprimeCabecalho(tamanho);
			/* Chamar o procedimento para mostrar o tabuleiro */
			MostraLamberta(tabuleiro, tamanho); 
		}		
	}	
}